/*---------------------------------------------------------------------------*/

/*!  \file  grammer.h
     \brief  -- some grammers for output scripts.  */

/*---------------------------------------------------------------------------*/

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_GRAMMER_H
#define INCLUDE_GRAMMER_H

/*---------------------------------------------------------------------------*/

#if defined(LUA)
    /*  for Lua  */

#define FILE_HEADER "-- generated by xudf2lua\n"
#define FILE_FOOTER ""

#define RECORD "record"
#define DATA "data"
#define HEADER "header"
#define UNIT "unit"
#define DEF "def"
#define GLOBAL "global"

#define HASH
#define VARIABLE
#define KEY(x) x

#define ASSIGNOR "="
#define ASSOCIATOR "="
#define SEPARATOR ","
#define TERMINATOR ""
#define HASH_TOP_LEFT "{"
#define HASH_TOP_RIGHT "}"
#define HASH_LEFT "{"
#define HASH_RIGHT "}"
#define ARRAY_LEFT "{"
#define ARRAY_RIGHT "}"
#define ACCESSOR_LEFT "["
#define ACCESSOR_RIGHT "]"

#elif defined(PYTHON)
    /*  for Python  */

#define FILE_HEADER "# generated by xudf2py\n"
#define FILE_FOOTER ""

#define RECORD "record"
#define DATA "data"
#define HEADER "header"
#define UNIT "unit"
#define DEF "define"
#define GLOBAL "global"

#define HASH
#define VARIABLE
#define KEY(x) "'" x "'"

#define ASSIGNOR "="
#define ASSOCIATOR ":"
#define SEPARATOR ","
#define TERMINATOR ""
#define HASH_TOP_LEFT "{"
#define HASH_TOP_RIGHT "}"
#define HASH_LEFT "{"
#define HASH_RIGHT "}"
#define ARRAY_LEFT "["
#define ARRAY_RIGHT "]"
#define ACCESSOR_LEFT "["
#define ACCESSOR_RIGHT "]"

#elif defined(RUBY)
    /*  for Ruby  */

#define FILE_HEADER "# generated by xudf2rb\n"
#define FILE_FOOTER ""

#define RECORD "record"
#define DATA "data"
#define HEADER "header"
#define UNIT "unit"
#define DEF "define"
#define GLOBAL "global"

#define HASH "$"
#define VARIABLE
#define KEY(x) "\"" x "\""

#define ASSIGNOR "="
#define ASSOCIATOR "=>"
#define SEPARATOR ","
#define TERMINATOR ""
#define HASH_TOP_LEFT "{"
#define HASH_TOP_RIGHT "}"
#define HASH_LEFT "{"
#define HASH_RIGHT "}"
#define ARRAY_LEFT "["
#define ARRAY_RIGHT "]"
#define ACCESSOR_LEFT "["
#define ACCESSOR_RIGHT "]"

#elif defined(PERL)
    /*  for Perl  */

#define FILE_HEADER "# generated by xudf2pl\n"
#define FILE_FOOTER ""

#define RECORD "record"
#define DATA "data"
#define HEADER "header"
#define UNIT "unit"
#define DEF "define"
#define GLOBAL "global"

#define HASH "%%"
#define VARIABLE "$"
#define KEY(x) "\"" x "\""

#define ASSIGNOR "="
#define ASSOCIATOR "=>"
#define SEPARATOR ","
#define TERMINATOR ";"
#define HASH_TOP_LEFT "("
#define HASH_TOP_RIGHT ")"
#define HASH_LEFT "{"
#define HASH_RIGHT "}"
#define ARRAY_LEFT "["
#define ARRAY_RIGHT "]"
#define ACCESSOR_LEFT "{"
#define ACCESSOR_RIGHT "}"

#else
#error LUA, PYTHON, RUBY or PERL must be defined.
#endif

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
