/*---------------------------------------------------------------------------*/

/*!  \file  tree.h
     \brief  XUDF (eXtened User Definable Format) data structure tree.  */

/*---------------------------------------------------------------------------*/

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_TREE_H
#define INCLUDE_TREE_H

#include <stdio.h>

/*---------------------------------------------------------------------------*/
typedef struct xudf_def_node
{
    struct xudf_def_node *next;
    struct xudf_def_node *child;
    char *name;
} xudf_def_node;

/*---------------------------------------------------------------------------*/
xudf_def_node *xudf_new_def_tree(char *xudfname);
xudf_def_node *xudf_add_next_def_node(xudf_def_node *xdef,
                                      char *xdefname);
xudf_def_node *xudf_add_child_def_node(xudf_def_node *xdef,
                                       char *xdefname);
void xudf_copy_child_def_node(xudf_def_node *xdef,xudf_def_node *xsub);
void xudf_free_def_tree(xudf_def_node *xdef);
xudf_def_node *xudf_find_def_node_by_name(xudf_def_node *xdef,char *xdefname);
xudf_def_node *xudf_find_def_node_by_name_or_exit(xudf_def_node *xdef,char *xdefname);
xudf_def_node *xudf_find_def_node_by_index(xudf_def_node *xdef,int index);
xudf_def_node *xudf_find_def_node_by_index_or_exit(xudf_def_node *xdef,int index);
void xudf_print_def_tree(FILE *fp,xudf_def_node *xdef);
void xudf_print_def_node(FILE *fp,xudf_def_node *xdef);

/*---------------------------------------------------------------------------*/
#endif

/*---------------------------------------------------------------------------*/
