/*---------------------------------------------------------------------------*/

/*!  \file  alist.h
     \brief  associated list for macro definition.  */

/*---------------------------------------------------------------------------*/

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_ALIST_H
#define INCLUDE_ALIST_H

#include <stdio.h>

#define XUDF_DEFINITION_SIZE 0x1000

/*---------------------------------------------------------------------------*/
typedef struct xudf_definition_alist
{
    char *name;
    char *definition;
    struct xudf_definition_alist *next;
} xudf_definition_alist;

/*---------------------------------------------------------------------------*/
xudf_definition_alist *xudf_new_definition_alist(char *name,char *definition);
xudf_definition_alist *xudf_add_definition_alist(xudf_definition_alist *xalist,
                                                 char *name,char *definition);
xudf_definition_alist *xudf_insert_definition_alist(xudf_definition_alist *xalist,
                                                    char *name,char *definition);
void xudf_free_definition_alist(xudf_definition_alist *xalist);
void xudf_print_definition_alist(FILE *fp,xudf_definition_alist *xalist);
char *xudf_find_definition_from_definition_alist(xudf_definition_alist *xalist,char *name);
char *xudf_find_definition_from_definition_alist_or_exit(xudf_definition_alist *xalist,char *name);

/*---------------------------------------------------------------------------*/
#endif
