/*---------------------------------------------------------------------------*/

/*!  \file  list.h
     \brief  include path list.  */

/*---------------------------------------------------------------------------*/

/* This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307,
   USA.  */

/*---------------------------------------------------------------------------*/
#ifndef INCLUDE_LIST_H
#define INCLUDE_LIST_H

#include <stdio.h>

#define XUDF_FILENAME_SIZE 0x1000

/*---------------------------------------------------------------------------*/
typedef struct xudf_path_list
{
    char *path;
    struct xudf_path_list *next;
} xudf_path_list;

/*---------------------------------------------------------------------------*/
xudf_path_list *xudf_new_path_list(char *path);
xudf_path_list *xudf_add_path_list(xudf_path_list *xlist,char *path);
xudf_path_list *xudf_insert_path_list(xudf_path_list *xlist,char *path);
void xudf_free_path_list(xudf_path_list *xlist);
void xudf_print_path_list(FILE *fp,xudf_path_list *xlist);
char *xudf_find_file_from_path_list(xudf_path_list *xlist,char *filename);
char *xudf_find_file_from_path_list_or_exit(xudf_path_list *xlist,char *filename);

/*---------------------------------------------------------------------------*/
#endif
